﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Threading;
using System.Reflection;
using System.Collections;

namespace round5Visualizer
{
    public partial class Form1 : Form
    {
        private const string inputFileName = "mytask.in";
        private int refreshRate;
        private Thread updater;
        private Executor solutionRunner;

        public Form1()
        {
            refreshRate = 100;
            InitializeComponent();
            this.MultipleImagesSelector.Filter = "Images (*.JPG)|*.JPG";
            this.openFileDialog1.Filter = "Images (*.JPG)|*.JPG";
            this.openFileDialog2.Filter = "Images (*.JPG)|*.JPG";

            solutionRunner = new Executor();
        }
        private delegate void SetControlPropertyThreadSafeDelegate(Control control, string propertyName, object propertyValue);

        public static void SetControlPropertyThreadSafe(Control control, string propertyName, object propertyValue)
        {
            if (control.InvokeRequired)
            {
                control.Invoke(new SetControlPropertyThreadSafeDelegate(SetControlPropertyThreadSafe), new object[] { control, propertyName, propertyValue });
            }
            else
            {
                control.GetType().InvokeMember(propertyName, BindingFlags.SetProperty, null, control, new object[] { propertyValue });
            }
        }

        private string getSuffixJpg(string filePath)
        {
            string result = "Choose jpg file";
            int last = -1;
            if (filePath.Length < 4)
                return result;
            if (filePath.Substring(filePath.Length -4) != ".jpg")
                return result;

            for (int i = 0; i < filePath.Length; ++i)
            {
                if (filePath[i] == '\\')
                    last = i;
            }

            result = filePath.Substring(last + 1);

            return result;
        }

        public int getRefreshRate()
        {
            return refreshRate;
        }

        public PictureBox getPictureBox1()
        {
            return pictureBox1;
        }

        public PictureBox getPictureBox2()
        {
            return pictureBox2;
        }

        public TextBox getTextBox1()
        {
            return textBox1;
        }

        public TextBox getProgress()
        {
            return Progress;
        }
        private string getSuffix(string filePath)
        {
            string result = "";

            int last = -1;

            for (int i = 0; i < filePath.Length; ++i)
            {
                if (filePath[i] == '\\')
                    last = i;
            }

            result = filePath.Substring(last + 1);

            return result;
        }

        public void changeStartImage()
        {
            pictureBox1.Image = new Bitmap(solutionRunner.getStartFilePath());
        }

        public void changeEndImage()
        {
            pictureBox2.Image = new Bitmap(solutionRunner.getEndFilePath());
        }


        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }

        private void SelectImage1(object sender, EventArgs e)
        {

        }

        private void openFileDialog2_FileOk(object sender, CancelEventArgs e)
        {

        }

        private void StartButtonClick(object sender, EventArgs e)
        {
            DialogResult result = openFileDialog1.ShowDialog();
            if (result == DialogResult.OK)
            {
                solutionRunner.setStartFilePath(openFileDialog1.FileName);
                startImageSelect.Text = getSuffixJpg(solutionRunner.getStartFilePath());
                if (solutionRunner.getStartFilePath().Contains(".") == true)
                    changeStartImage();

            }
        }

        private void FinalButtonClick(object sender, EventArgs e)
        {
            DialogResult result = openFileDialog2.ShowDialog();
            if (result == DialogResult.OK)
            {
                solutionRunner.setEndFilePath(openFileDialog2.FileName);
                finalImageSelect.Text = getSuffixJpg(solutionRunner.getEndFilePath());
                if (solutionRunner.getEndFilePath().Contains(".") == true)
                    changeEndImage();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (solutionRunner.getStartFilePath().Contains(".") == false || solutionRunner.getEndFilePath().Contains(".") == false)
            {
                MessageBox.Show("Input file generation failed! Select both images!", "Need more input",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else if (solutionRunner.getNumberOfOperations() == -1)
            {
                MessageBox.Show("Input file generation failed! Enter Number of Operations!", "Need more input",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else
            {
                if (solutionRunner.createInputFile(inputFileName) == false)
                {
                    return;
                }

                MessageBox.Show("Input file created.", "Done!",
                MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void openFileDialog3_FileOk(object sender, CancelEventArgs e)
        {

        }



        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void runProgram(bool isMultiple)
        {
            
            solutionRunner.createInputFile("mytask.in");
            if (solutionRunner.runSolution("mytask.in", "mytask.out") == false)
            {
                MessageBox.Show("Error while trying to run program", "Error!",
                MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            try
            {
                double val = solutionRunner.visualizeSolution(this, "mytask.out", isMultiple);
                if (isMultiple == false)
                {
                    if (val != -1)
                    {
                        MessageBox.Show("Score: " + val.ToString(), "Done!",
                        MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                }
                else
                {
                    if (val != -1)
                    {
                        using (System.IO.StreamWriter file = new System.IO.StreamWriter("score.log", true))
                        {
                            file.Write("(" + getSuffixJpg(solutionRunner.getStartFilePath()) + ") ->");
                            file.Write("(" + getSuffixJpg(solutionRunner.getEndFilePath()) + ") = ");
                            file.WriteLine(val + " score");
                        }
                    }
                    else
                    {
                        using (System.IO.StreamWriter file = new System.IO.StreamWriter("score.log", true))
                        {
                            file.Write("(" + getSuffixJpg(solutionRunner.getStartFilePath()) + ") ->");
                            file.Write("(" + getSuffixJpg(solutionRunner.getEndFilePath()) + ") = ");
                            file.WriteLine(" error");
                        }
                    }

                }
            }
            catch
            {
                if (isMultiple == false)
                {
                    MessageBox.Show("Invalid output file", "Error",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                else
                {
                    using (System.IO.StreamWriter file = new System.IO.StreamWriter("score.log", true))
                    {

                        file.Write("(" +getSuffixJpg(solutionRunner.getStartFilePath())+ ") ->");
                        file.Write("(" +getSuffixJpg(solutionRunner.getEndFilePath())+ ") = ");
                        file.WriteLine("Invalid output file");

                    }
                }
            }

        }
        //run one test 
        public void Run_Click(object sender, EventArgs e)
        {
            if (updater != null)
            {
                if (updater.IsAlive)
                    return;
            }

            if (solutionRunner.getStartFilePath().Contains(".") == false || solutionRunner.getEndFilePath().Contains(".") == false)
            {
                MessageBox.Show("Select both images!", "Need more input",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (updater != null)
                if (updater.IsAlive)
                    updater.Abort();

            updater = new Thread(() => runProgram(false));
            updater.IsBackground = true;    
            updater.Start();

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int idx = comboBox1.SelectedIndex;
            if (idx == 0)
                refreshRate = 10;
            else if (idx == 1)
                refreshRate = 50;
            else if (idx == 2)
                refreshRate = 100;
            else if (idx == 3)
                refreshRate = 1000;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            try
            {
                solutionRunner.setNumberOfOperations(System.Convert.ToInt32(textBox1.Text));
            }
            catch (FormatException)
            {
                solutionRunner.setNumberOfOperations(-1);
            }
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }


        private void comm_TextChanged_1(object sender, EventArgs e)
        {
            solutionRunner.setCommand(comm.Text);
          
        }

        private void MultipleImagesSelector_FileOk(object sender, CancelEventArgs e)
        {
          
        }

        private void SelectListOfImages_Click(object sender, EventArgs e)
        {
            DialogResult result = MultipleImagesSelector.ShowDialog();
            if (result == DialogResult.OK)
            {
                String[] tmp = MultipleImagesSelector.FileNames;
                ArrayList onlyImages = new ArrayList();
                for (int i = 0; i < tmp.Length; ++i)
                    if (getSuffixJpg(tmp[i]).Contains(".") == true)
                        onlyImages.Add(tmp[i]);

                solutionRunner.setListOfImages(onlyImages.ToArray(typeof(String)) as string[]);
            }
        }

        //run multiple tests
        private void runAll()
        {
            File.Delete("score.log");

            string[] listOfImages = solutionRunner.getListOfImages();

            for (int i = 0; i < listOfImages.Length; ++i)
                for (int j = 0; j < listOfImages.Length; ++j)
                    if (i != j)
                    {
                        solutionRunner.setStartFilePath(listOfImages[i]);
                        solutionRunner.setEndFilePath(listOfImages[j]);
                        runProgram(true);
                    }

        }

        //click run all event
        private void button1_Click_1(object sender, EventArgs e)
        {
            if (updater != null)
            {
                if (updater.IsAlive)
                {
                    return;
                }
            }
            if (solutionRunner.getListOfImages().Length < 2)
            {
                MessageBox.Show("Need more than one image", "Error!",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            updater = new Thread(runAll);
            updater.IsBackground = true;
            updater.Start();

        }
    }
}
